import { Stack } from "aws-cdk-lib/core";
import type { Construct } from "constructs";
type ConstructInstance<F extends (this: InstanceType<Base>, props?: any) => any, Base extends new (scope: Construct, id: string, props?: any) => any = typeof Construct> = {
    construct: InstanceType<Base> & Awaited<ReturnType<F>>;
} & (undefined extends Parameters<F>[0] ? {
    new (scope: Construct, id: string): InstanceType<Base> & ReturnType<F>;
} : Parameters<F>[0] extends undefined ? {
    new (scope: Construct, id: string, props?: Parameters<F>[0]): InstanceType<Base> & ReturnType<F>;
} : {
    new (scope: Construct, id: string, props: Parameters<F>[0]): InstanceType<Base> & ReturnType<F>;
});
export declare function stack<F extends (this: Stack, props?: any) => any>(func: F): ConstructInstance<F, typeof Stack>;
export declare function construct<F extends (this: InstanceType<Base>, props?: any) => any, Base extends new (scope: Construct, id: string, props?: any) => any = typeof Construct>(func: F, base?: Base): ConstructInstance<F, Base>;
declare module "constructs" {
    interface Construct {
        create<F extends (this: Stack) => any>(id: string, func: F): ReturnType<F>;
        create<F extends (this: Construct) => any>(id: string, func: F): ReturnType<F>;
        create<F extends (this: Stack) => any>(func: F): ReturnType<F>;
        create<F extends (this: Construct) => any>(func: F): ReturnType<F>;
    }
}
export {};
